## libyang 3.4.2+dfsg

=== debian/changelog ===
libyang (3.4.2+dfsg-2) sid; urgency=medium

  * Uploading to sid.
  * Renaming source package to libyang, given that libyang 1.x has been
    replaced and removed pre-bookworm.
  * Updating vcs fields for source package rename.
  * Renaming libyang3-dev to libyang-dev before any package starts using
    it just yet.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 30 Sep 2024 07:06:28 +0200

libyang3 (3.4.2+dfsg-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 3.4.2+dfsg.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 17 Sep 2024 05:00:18 +0200

libyang3 (3.1.0+dfsg-5) sid; urgency=medium

  * Uploading to sid.
  * Removing pre-oldstable libyang conflicts/replaces.
  * Adding conflicts/replaces for libyang2 (Closes: #1078133).
  * Replacing libyang2 conflicts with breaks.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 08 Aug 2024 16:50:49 +0200

libyang3 (3.1.0+dfsg-4) sid; urgency=medium

  * Uploading to sid.
  * Adding missing conflicts/replaces to libyang-dev and libyang2-dev
    (Closes: #1077494).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 29 Jul 2024 15:29:51 +0200

libyang3 (3.1.0+dfsg-3) sid; urgency=medium

  * Uploading to sid.
  * Correcting watch file.
  * Reordering nodoc filter in rules for consistency.
  * Adding tcl-expect to build-depends to fix test failures on armel,
    armhf and i386.
  * Wrap-and-sorting libyang3-dev.install.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 27 Jul 2024 06:42:15 +0200

libyang3 (3.1.0+dfsg-2) sid; urgency=medium

  * Uploading to sid.
  * Using codenames in changelog.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 27 Jul 2024 02:08:13 +0200

libyang3 (3.1.0+dfsg-1) sid; urgency=medium

  * Initial upload to sid.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 23 Jul 2024 11:42:29 +0200

=== debian/control ===
Source: libyang
Section: libs
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libcmocka-dev <!nocheck>,
 libpcre2-dev,
 pkgconf,
 tcl-expect <!nocheck>,
 tclsh <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/CESNET/libyang
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/libyang
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/libyang

Package: libyang-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libpcre2-dev,
 libyang3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libyang2-dev,
 libyang3-dev,
Replaces:
 libyang2-dev,
 libyang3-dev,
Description: parser toolkit for IETF YANG data modeling language (development)
 YANG is a data modeling language for the definition of data sent over network
 management protocols (RFC 6020/7950). It can be used to model both configuration
 data as well as state data of network elements and is primarily used by larger
 network equipment like routers and switches.
 .
 This package contains the development files.

Package: libyang3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libyang2,
 libyang2t64,
Replaces:
 libyang2,
 libyang2t64,
Description: parser toolkit for IETF YANG data modeling language (library)
 YANG is a data modeling language for the definition of data sent over network
 management protocols (RFC 6020/7950). It can be used to model both configuration
 data as well as state data of network elements and is primarily used by larger
 network equipment like routers and switches.
 .
 This package contains the shared library.

Package: libyang3-tools
Section: devel
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libyang2-tools,
Replaces:
 libyang2-tools,
Description: parser toolkit for IETF YANG data modeling language (tools)
 YANG is a data modeling language for the definition of data sent over network
 management protocols (RFC 6020/7950). It can be used to model both configuration
 data as well as state data of network elements and is primarily used by larger
 network equipment like routers and switches.
 .
 This package contains additional tools.

## libyang 3.7.8

=== CMakeLists.txt ===
if(WIN32)
    cmake_minimum_required(VERSION 3.22.0)
else()
    cmake_minimum_required(VERSION 2.8.12...3.28.1)
endif()

# force out-of-source build
if(${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
    message(FATAL_ERROR "In-source build is not allowed. Please make a standalone build directory and run CMake from there. You may need to remove CMakeCache.txt.")
endif()

project(libyang C)

# include custom Modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/")

include(GNUInstallDirs)
include(UseCompat)
include(ABICheck)
include(SourceFormat)
include(GenDoc)
include(GenCoverage)

# set default build type if not specified by user
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()
# normalize build type string
# see https://github.com/CESNET/libyang/pull/1692 for why CMAKE_C_FLAGS_<type> are not used directly
string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_TYPE_UPPER)
if ("${BUILD_TYPE_UPPER}" STREQUAL "RELEASE")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
    set(CMAKE_C_FLAGS "-DNDEBUG -O2 ${CMAKE_C_FLAGS}")
elseif("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG")
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Build Type" FORCE)
    set(CMAKE_C_FLAGS "-g3 -O0 ${CMAKE_C_FLAGS}")
elseif("${BUILD_TYPE_UPPER}" STREQUAL "RELWITHDEBINFO")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build Type" FORCE)
elseif("${BUILD_TYPE_UPPER}" STREQUAL "RELWITHDEBUG")
    set(CMAKE_BUILD_TYPE "RelWithDebug" CACHE STRING "Build Type" FORCE)
elseif("${BUILD_TYPE_UPPER}" STREQUAL "ABICHECK")
    set(CMAKE_BUILD_TYPE "ABICheck" CACHE STRING "Build Type" FORCE)
    set(CMAKE_C_FLAGS "-g -Og ${CMAKE_C_FLAGS}")
elseif("${BUILD_TYPE_UPPER}" STREQUAL "DOCONLY")
    set(CMAKE_BUILD_TYPE "DocOnly" CACHE STRING "Build Type" FORCE)
endif()

#
# variables
#

set(LIBYANG_DESCRIPTION "libyang is YANG data modelling language parser and toolkit written (and providing API) in C.")

# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

# keep all binaries in the build directory
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# set version of the project
set(LIBYANG_MAJOR_VERSION 3)
set(LIBYANG_MINOR_VERSION 7)
set(LIBYANG_MICRO_VERSION 8)
set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})

# set version of the library
set(LIBYANG_MAJOR_SOVERSION 3)
set(LIBYANG_MINOR_SOVERSION 6)
set(LIBYANG_MICRO_SOVERSION 10)
set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

if(WIN32)
    set(C_STANDARD 11)
    set(C_STANDARD_REQUIRED ON)
    set(CMAKE_C_FLAGS "/Zc:preprocessor /W3 /wd4711 /w14013 /utf-8 ${CMAKE_C_FLAGS}")
else()
    # global C flags
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wpedantic -std=c11")
endif()

include_directories(${PROJECT_BINARY_DIR}/libyang ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/src/plugins_exts)

# type plugins are separate because they have their documentation generated
set(type_plugins
    src/plugins_types/binary.c
    src/plugins_types/bits.c
    src/plugins_types/boolean.c
    src/plugins_types/decimal64.c
    src/plugins_types/empty.c
    src/plugins_types/enumeration.c
    src/plugins_types/identityref.c
    src/plugins_types/instanceid.c
    src/plugins_types/instanceid_keys.c
    src/plugins_types/integer.c
    src/plugins_types/leafref.c
    src/plugins_types/lyds_tree.c
    src/plugins_types/string.c
    src/plugins_types/union.c
    src/plugins_types/ipv4_address.c
    src/plugins_types/ipv4_address_no_zone.c
    src/plugins_types/ipv6_address.c
    src/plugins_types/ipv6_address_no_zone.c
    src/plugins_types/ipv4_prefix.c
    src/plugins_types/ipv6_prefix.c
    src/plugins_types/date_and_time.c
    src/plugins_types/hex_string.c
    src/plugins_types/xpath1.0.c
    src/plugins_types/node_instanceid.c
    src/plugins_types/time_period.c)

set(libsrc
    src/ly_common.c
    src/log.c
    src/hash_table.c
    src/dict.c
    src/set.c
    src/path.c
    src/diff.c
    src/context.c
    src/json.c
    src/tree_data.c
    src/tree_data_free.c
    src/tree_data_common.c
    src/tree_data_hash.c
    src/tree_data_new.c
    src/parser_xml.c
    src/parser_json.c
    src/parser_lyb.c
    src/out.c
    src/printer_data.c
    src/printer_xml.c
    src/printer_json.c
    src/printer_lyb.c
    src/schema_compile.c
    src/schema_compile_node.c
    src/schema_compile_amend.c
    src/schema_features.c
    src/tree_data_sorted.c
    src/tree_schema.c
    src/tree_schema_free.c
    src/tree_schema_common.c
    src/in.c
    src/lyb.c
    src/parser_common.c
    src/parser_yang.c
    src/parser_yin.c
    src/printer_schema.c
    src/printer_yang.c
    src/printer_yin.c
    src/printer_tree.c
    src/plugins.c
    src/plugins_types.c
    src/plugins_exts.c
    src/plugins_exts/metadata.c
    src/plugins_exts/nacm.c
    src/plugins_exts/yangdata.c
    src/plugins_exts/schema_mount.c
    src/plugins_exts/structure.c
    src/xml.c
    src/xpath.c
    src/validation.c
    ${type_plugins})

set(headers
    src/context.h
    src/hash_table.h
    src/dict.h
    src/in.h
    src/libyang.h
    src/log.h
    src/out.h
    src/parser_data.h
    src/parser_schema.h
    src/plugins.h
    src/plugins_exts.h
    src/plugins_exts/metadata.h
    src/plugins_types.h
    src/printer_data.h
    src/printer_schema.h
    src/set.h
    src/tree.h
    src/tree_data.h
    src/tree_edit.h
    src/tree_schema.h)

set(internal_headers
    src/ly_common.h
    src/diff.h
    src/hash_table_internal.h
    src/in_internal.h
    src/json.h
    src/lyb.h
    src/out_internal.h
    src/parser_internal.h
    src/path.h
    src/plugins_internal.h
    src/printer_internal.h
    src/schema_compile.h
    src/schema_compile_amend.h
    src/schema_compile_node.h
    src/schema_features.h
    src/tree_data_internal.h
    src/tree_schema_internal.h
    src/validation.h
    src/xml.h
    src/xpath.h)

set(gen_headers
    version.h
    ly_config.h)

# files to generate doxygen from
set(doxy_files
    doc/build.dox
    doc/transition_1_2.dox
    doc/transition_2_3.dox
    ${headers}
    ${PROJECT_BINARY_DIR}/libyang/version.h
    ${type_plugins})

# project (doxygen) logo
set(project_logo
    doc/logo.png)

# source files to be covered by the 'format' target
set(format_sources
    compat/*.c
    compat/*.h*
    src/*.c
    src/*.h
    src/plugins_exts/*
    src/plugins_types/*)
#
# options
#

if(("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG") OR ("${BUILD_TYPE_UPPER}" STREQUAL "RELWITHDEBINFO"))
    option(ENABLE_TESTS "Build tests" ON)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" ON)
else()
    option(ENABLE_TESTS "Build tests" OFF)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" OFF)
endif()
option(ENABLE_PERF_TESTS "Build performance tests" OFF)
option(ENABLE_COVERAGE "Build code coverage report from tests" OFF)
option(ENABLE_FUZZ_TARGETS "Build target programs suitable for fuzzing with AFL" OFF)
option(ENABLE_INTERNAL_DOCS "Generate doxygen documentation also from internal headers" OFF)
option(ENABLE_YANGLINT_INTERACTIVE "Enable interactive CLI yanglint" ON)
option(ENABLE_TOOLS "Build binary tools 'yanglint' and 'yangre'" ON)
option(ENABLE_COMMON_TARGETS "Define common custom target names such as 'doc' or 'uninstall', may cause conflicts when using add_subdirectory() to build this project" ON)
option(BUILD_SHARED_LIBS "By default, shared libs are enabled. Turn off for a static build." ON)
set(YANG_MODULE_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/yang/modules/libyang" CACHE STRING "Directory where to copy the YANG modules to")

if(ENABLE_INTERNAL_DOCS)
    set(doxy_files ${doxy_files} ${internal_headers})
    set(INTERNAL_DOCS YES)
else()
    set(INTERNAL_DOCS NO)
endif()

set(LYD_VALUE_SIZE "24" CACHE STRING "Maximum size in bytes of data node values that do not need to be allocated dynamically, minimum is 8")
if(LYD_VALUE_SIZE LESS 8)
    message(FATAL_ERROR "Data node value size \"${LYD_VALUE_SIZE}\" is not valid.")
endif()
set(PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libyang" CACHE STRING "Directory with libyang plugins (extensions and user types)")
set(PLUGINS_DIR_EXTENSIONS "${PLUGINS_DIR}/extensions" CACHE STRING "Directory with libyang user extensions plugins")
set(PLUGINS_DIR_TYPES "${PLUGINS_DIR}/types" CACHE STRING "Directory with libyang user types plugins")

#
# checks
#
if(NOT BUILD_SHARED_LIBS)
    message(STATUS "Disabling tests for static build")
    set(ENABLE_TESTS OFF)
    set(ENABLE_VALGRIND_TESTS OFF)
endif()

if(ENABLE_VALGRIND_TESTS)
    if(NOT ENABLE_TESTS)
        message(WARNING "Tests are disabled! Disabling memory leak tests.")
        set(ENABLE_VALGRIND_TESTS OFF)
    else()
        find_program(VALGRIND_FOUND valgrind)
        if(NOT VALGRIND_FOUND)
            message(WARNING "valgrind executable not found! Disabling memory leak tests.")
            set(ENABLE_VALGRIND_TESTS OFF)
        endif()
    endif()
endif()

if(ENABLE_TESTS)
    find_package(CMocka 1.0.1)
    if(NOT CMOCKA_FOUND)
        message(STATUS "Disabling tests because of missing CMocka")
        set(ENABLE_TESTS OFF)
    endif()
endif()

if(ENABLE_PERF_TESTS)
    find_path(VALGRIND_INCLUDE_DIR
        NAMES
        valgrind/callgrind.h
        PATHS
        /usr/include
        /usr/local/include
        /opt/local/include
        /sw/include
        ${CMAKE_INCLUDE_PATH}
        ${CMAKE_INSTALL_PREFIX}/include)
    if(VALGRIND_INCLUDE_DIR)
        set(HAVE_CALLGRIND 1)
    else()
        message(STATUS "Disabling callgrind macros in performance tests because of missing valgrind headers")
    endif()
endif()

if(ENABLE_COVERAGE)
    gen_coverage_enable(${ENABLE_TESTS})
endif()

if ("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG")
    # enable before adding tests to let them detect that format checking is available - one of the tests is format checking
    source_format_enable(0.77)
endif()

# generate and copy all public header files
configure_file(${PROJECT_SOURCE_DIR}/src/ly_config.h.in ${PROJECT_BINARY_DIR}/libyang/ly_config.h @ONLY)
configure_file(${PROJECT_SOURCE_DIR}/src/version.h.in ${PROJECT_BINARY_DIR}/libyang/version.h @ONLY)
file(COPY ${headers} DESTINATION ${PROJECT_BINARY_DIR}/libyang)

# DOC-only target with no extra dependencies
if("${BUILD_TYPE_UPPER}" STREQUAL "DOCONLY")
    gen_doc("${doxy_files}" ${LIBYANG_VERSION} ${LIBYANG_DESCRIPTION} ${project_logo})
    return()
endif()

#
# targets
#

# link compat
use_compat()

# create static libyang library
if(NOT BUILD_SHARED_LIBS)
    add_definitions(-DSTATIC)

    # allow binaries compilation linking both static and dynamic libraries never linking static glibc
    #set(CMAKE_EXE_LINKER_FLAGS -static)

    # prefer static libraries
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a;.so)
    set(CMAKE_LINK_SEARCH_START_STATIC TRUE)

    set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)       # remove -Wl,-Bdynamic
    set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    add_library(yang STATIC ${libsrc} ${compatsrc})
else()
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
    add_library(yangobj OBJECT ${libsrc} ${compatsrc})
    if(NOT WIN32)
        set_target_properties(yangobj PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
    endif()
    target_compile_definitions(yangobj PRIVATE LIBYANG_BUILD)
    add_library(yang SHARED $<TARGET_OBJECTS:yangobj>)

    if(WIN32)
        find_package(dlfcn-win32 REQUIRED)
        set(CMAKE_DL_LIBS dlfcn-win32::dl)
    endif()

    #link dl
    target_link_libraries(yang ${CMAKE_DL_LIBS})
endif()

if(WIN32)
    find_path(DIRENT_INCLUDE_DIR NAMES dirent.h REQUIRED)
    message(STATUS "Found <dirent.h> at ${DIRENT_INCLUDE_DIR}")

    set(COMPAT_POSIX_INCLUDES
        ${CMAKE_CURRENT_SOURCE_DIR}/compat/posix-shims
        ${DIRENT_INCLUDE_DIR})

    if(TARGET yangobj)
        target_include_directories(yangobj PRIVATE ${COMPAT_POSIX_INCLUDES})
    endif()

=== tests/yanglint/CMakeLists.txt ===
if(WIN32 OR NOT ENABLE_YANGLINT_INTERACTIVE)
    set(YANGLINT_INTERACTIVE OFF)
else()
    set(YANGLINT_INTERACTIVE ON)
endif()

function(add_yanglint_test)
    cmake_parse_arguments(ADDTEST "" "NAME;VIA;SCRIPT" "" ${ARGN})
    set(TEST_NAME yanglint_${ADDTEST_NAME})

    if(${ADDTEST_VIA} STREQUAL "tclsh")
        set(WRAPPER ${PATH_TCLSH})
    else()
        message(FATAL_ERROR "build: unexpected wrapper '${ADDTEST_VIA}'")
    endif()

    add_test(NAME ${TEST_NAME} COMMAND ${WRAPPER} ${CMAKE_CURRENT_SOURCE_DIR}/${ADDTEST_SCRIPT})
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "TESTS_DIR=${CMAKE_CURRENT_SOURCE_DIR}")
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "YANG_MODULES_DIR=${CMAKE_CURRENT_SOURCE_DIR}/modules")
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "YANGLINT=${PROJECT_BINARY_DIR}")
endfunction(add_yanglint_test)

if(ENABLE_TESTS)
    # tests of interactive mode using tclsh
    find_program(PATH_TCLSH NAMES tclsh)
    if(NOT PATH_TCLSH)
        message(WARNING "'tclsh' not found! The yanglint(1) interactive tests will not be available.")
    else()
        if(YANGLINT_INTERACTIVE)
            add_yanglint_test(NAME interactive VIA tclsh SCRIPT interactive/all.tcl)
            add_yanglint_test(NAME non-interactive VIA tclsh SCRIPT non-interactive/all.tcl)
        else()
            add_yanglint_test(NAME non-interactive VIA tclsh SCRIPT non-interactive/all.tcl)
        endif()
    endif()
endif()

=== debian/changelog ===
libyang (3.7.8-3) sid; urgency=medium

  * Updating vcs fields.

 -- Daniel Baumann <daniel@debian.org>  Sun, 16 Feb 2025 20:29:12 +0100

libyang (3.7.8-2) sid; urgency=medium

  * Updating vcs fields.
  * Trimming changelog.
  * Updating email address.
  * Updating year in debian copyright for 2025.

 -- Daniel Baumann <daniel@debian.org>  Wed, 05 Feb 2025 09:10:56 +0100

libyang (3.7.8-1) sid; urgency=medium

  * Merging upstream version 3.7.8.
  * Removing now uneeded breaks/replaces on libyang3-dev.
  * Updating source url in copyright.

 -- Daniel Baumann <daniel@debian.org>  Tue, 14 Jan 2025 11:13:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: libyang
 Section: libs
 Priority: optional
-Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
+Maintainer: Daniel Baumann <daniel@debian.org>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -15,8 +15,8 @@
 Rules-Requires-Root: no
 Standards-Version: 4.7.0
 Homepage: https://github.com/CESNET/libyang
-Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/libyang
-Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/libyang
+Vcs-Browser: https://forgejo.debian.net/frr/libyang
+Vcs-Git: https://forgejo.debian.net/frr/libyang
 
 Package: libyang-dev
 Section: libdevel
@@ -29,10 +29,8 @@
  ${shlibs:Depends},
 Breaks:
  libyang2-dev,
- libyang3-dev,
 Replaces:
  libyang2-dev,
- libyang3-dev,
 Description: parser toolkit for IETF YANG data modeling language (development)
  YANG is a data modeling language for the definition of data sent over network
  management protocols (RFC 6020/7950). It can be used to model both configuration

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libyang-$1\.tar\.gz/, \
 dversionmangle=s/\+dfsg//" \
https://github.com/CESNET/libyang/tags .*/v?(\d\S+)\.tar\.gz

## libyang 3.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,14 +59,14 @@
 
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 3)
-set(LIBYANG_MINOR_VERSION 7)
-set(LIBYANG_MICRO_VERSION 8)
+set(LIBYANG_MINOR_VERSION 12)
+set(LIBYANG_MICRO_VERSION 2)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 3)
-set(LIBYANG_MINOR_SOVERSION 6)
-set(LIBYANG_MICRO_SOVERSION 10)
+set(LIBYANG_MINOR_SOVERSION 9)
+set(LIBYANG_MICRO_SOVERSION 1)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

=== tests/plugins/CMakeLists.txt ===
include(CMakeParseArguments)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

function(ly_add_plugin)
    cmake_parse_arguments(ADDPLUGIN "" "NAME" "SOURCES" ${ARGN})
    set(PLUGIN_NAME plugin_${ADDPLUGIN_NAME})

    foreach(PLUGIN_SOURCE ${ADDPLUGIN_SOURCES})
        list(APPEND PLUGIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/${PLUGIN_SOURCE})
    endforeach()

    add_library(${PLUGIN_NAME} MODULE ${PLUGIN_SOURCES})
    set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
    target_link_libraries(${PLUGIN_NAME} yang)
endfunction(ly_add_plugin)

ly_add_plugin(NAME invalid SOURCES invalid.c)
ly_add_plugin(NAME simple SOURCES simple.c)

=== debian/changelog ===
libyang (3.12.2-1ubuntu1) questing; urgency=medium

  * d/tests: add tests from src:libyang2 (LP: #2120456)

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 12 Aug 2025 12:58:07 -0300

libyang (3.12.2-1) sid; urgency=medium

  * Simplifying watch file.
  * Merging upstream version 3.12.2.
  * Updating year in upstream copyright for 2025.
  * Adding build-depends to libxxhash-dev for faster hashing.
  * Wrap and sorting debian files.

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 May 2025 04:15:49 +0200

libyang (3.7.8-5) sid; urgency=medium

  * Removing multi-arch field for libyang-dev (Closes: #1100921).

 -- Daniel Baumann <daniel@debian.org>  Thu, 20 Mar 2025 15:14:20 +0100

libyang (3.7.8-4) sid; urgency=medium

  * Updating to standards version 4.7.1.
  * Updating to standards version 4.7.2.

 -- Daniel Baumann <daniel@debian.org>  Wed, 19 Mar 2025 20:11:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: libyang
 Section: libs
 Priority: optional
-Maintainer: Daniel Baumann <daniel@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Daniel Baumann <daniel@debian.org>
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  doxygen <!nodoc>,
  graphviz <!nodoc>,
  libcmocka-dev <!nocheck>,
  libpcre2-dev,
+ libxxhash-dev,
  pkgconf,
  tcl-expect <!nocheck>,
  tclsh <!nocheck>,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/CESNET/libyang
 Vcs-Browser: https://forgejo.debian.net/frr/libyang
 Vcs-Git: https://forgejo.debian.net/frr/libyang
@@ -21,7 +23,6 @@
 Package: libyang-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
 Depends:
  libpcre2-dev,
  libyang3 (= ${binary:Version}),

=== debian/tests/control ===
Tests: yanglint
Depends: gzip,
         libyang3-tools

Tests: yangre
Depends: libyang3-tools

## libyang 3.13.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,14 +59,14 @@
 
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 3)
-set(LIBYANG_MINOR_VERSION 12)
-set(LIBYANG_MICRO_VERSION 2)
+set(LIBYANG_MINOR_VERSION 13)
+set(LIBYANG_MICRO_VERSION 5)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 3)
 set(LIBYANG_MINOR_SOVERSION 9)
-set(LIBYANG_MICRO_SOVERSION 1)
+set(LIBYANG_MICRO_SOVERSION 13)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})
 
@@ -242,7 +242,6 @@
     option(ENABLE_TESTS "Build tests" OFF)
     option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" OFF)
 endif()
-option(ENABLE_PERF_TESTS "Build performance tests" OFF)
 option(ENABLE_COVERAGE "Build code coverage report from tests" OFF)
 option(ENABLE_FUZZ_TARGETS "Build target programs suitable for fuzzing with AFL" OFF)
 option(ENABLE_INTERNAL_DOCS "Generate doxygen documentation also from internal headers" OFF)
@@ -297,22 +296,20 @@
     endif()
 endif()
 
-if(ENABLE_PERF_TESTS)
-    find_path(VALGRIND_INCLUDE_DIR
-        NAMES
-        valgrind/callgrind.h
-        PATHS
-        /usr/include
-        /usr/local/include
-        /opt/local/include
-        /sw/include
-        ${CMAKE_INCLUDE_PATH}
-        ${CMAKE_INSTALL_PREFIX}/include)
-    if(VALGRIND_INCLUDE_DIR)
-        set(HAVE_CALLGRIND 1)
-    else()
-        message(STATUS "Disabling callgrind macros in performance tests because of missing valgrind headers")
-    endif()
+find_path(VALGRIND_INCLUDE_DIR
+    NAMES
+    valgrind/callgrind.h
+    PATHS
+    /usr/include
+    /usr/local/include
+    /opt/local/include
+    /sw/include
+    ${CMAKE_INCLUDE_PATH}
+    ${CMAKE_INSTALL_PREFIX}/include)
+if(VALGRIND_INCLUDE_DIR)
+    set(HAVE_CALLGRIND 1)
+else()
+    message(STATUS "Disabling callgrind macros in performance tests because of missing valgrind headers")
 endif()
 
 if(ENABLE_COVERAGE)
@@ -385,3 +382,6 @@
     if(TARGET yangobj)
         target_include_directories(yangobj PRIVATE ${COMPAT_POSIX_INCLUDES})
     endif()
+    target_include_directories(yang PRIVATE ${COMPAT_POSIX_INCLUDES})
+    include_directories(${COMPAT_POSIX_INCLUDES})
+

=== tests/perf/CMakeLists.txt ===
set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/perf.c
    PARENT_SCOPE)

add_executable(ly_perf ${CMAKE_CURRENT_SOURCE_DIR}/perf.c $<TARGET_OBJECTS:yangobj>)
set_target_properties(ly_perf PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests")
target_link_libraries(ly_perf ${CMAKE_THREAD_LIBS_INIT} ${PCRE2_LIBRARIES} ${CMAKE_DL_LIBS})
if(XXHASH_FOUND)
    target_link_libraries(ly_perf ${XXHASH_LIBRARY})
endif()

if(NOT WIN32)
    target_link_libraries(ly_perf m)
endif()

=== tests/yanglint/CMakeLists.txt ===
--- 
+++ 
@@ -23,8 +23,11 @@
 if(ENABLE_TESTS)
     # tests of interactive mode using tclsh
     find_program(PATH_TCLSH NAMES tclsh)
+    find_program(PATH_EXPECT NAMES expect)
     if(NOT PATH_TCLSH)
-        message(WARNING "'tclsh' not found! The yanglint(1) interactive tests will not be available.")
+        message(WARNING "tclsh not found, yanglint(1) interactive tests will not be available.")
+    elseif(NOT PATH_EXPECT)
+        message(WARNING "expect not found, yanglint(1) interactive tests will not be available.")
     else()
         if(YANGLINT_INTERACTIVE)
             add_yanglint_test(NAME interactive VIA tclsh SCRIPT interactive/all.tcl)

=== tools/re/CMakeLists.txt ===
# yangre

set(resrc
    main.c)

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    PARENT_SCOPE)

add_executable(yangre ${resrc} ${compatsrc})
target_link_libraries(yangre yang)
install(TARGETS yangre DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${PROJECT_SOURCE_DIR}/tools/re/yangre.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
target_include_directories(yangre BEFORE PRIVATE ${PROJECT_BINARY_DIR})

if(WIN32)
    target_include_directories(yangre PRIVATE ${GETOPT_INCLUDE_DIR})
    target_link_libraries(yangre ${GETOPT_LIBRARY})
endif()

=== debian/changelog ===
libyang (3.13.5-2) sid; urgency=medium

  * Adding back autopkgtests from libyang2, thanks to Andreas Hasenack
    <andreas.hasenack@canonical.com> (Closes: #1110926).

 -- Daniel Baumann <daniel@debian.org>  Tue, 12 Aug 2025 17:56:18 +0200

libyang (3.13.5-1) sid; urgency=medium

  * Adding upstream metadata.
  * Merging upstream version 3.13.5.

 -- Daniel Baumann <daniel@debian.org>  Sun, 10 Aug 2025 20:33:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libyang
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Daniel Baumann <daniel@debian.org>
+Maintainer: Daniel Baumann <daniel@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,

=== debian/tests/control ===
Tests:
 yanglint,
Depends:
 gzip,
 libyang3-tools,

Tests:
 yangre,
Depends:
 libyang3-tools,

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//" \
https://github.com/CESNET/libyang/tags .*/v?(\d.*)@ARCHIVE_EXT@

## libyang 3.13.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,13 +60,13 @@
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 3)
 set(LIBYANG_MINOR_VERSION 13)
-set(LIBYANG_MICRO_VERSION 5)
+set(LIBYANG_MICRO_VERSION 6)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 3)
 set(LIBYANG_MINOR_SOVERSION 9)
-set(LIBYANG_MICRO_SOVERSION 13)
+set(LIBYANG_MICRO_SOVERSION 14)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

=== tests/CMakeLists.txt ===
# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

configure_file("${PROJECT_SOURCE_DIR}/tests/tests_config.h.in" "${PROJECT_BINARY_DIR}/tests/tests_config.h" ESCAPE_QUOTES @ONLY)
include_directories(SYSTEM ${CMOCKA_INCLUDE_DIR})
include_directories(${PROJECT_BINARY_DIR}/tests/)

function(ly_add_utest)
    cmake_parse_arguments(ADDTEST "" "NAME;WRAP" "SOURCES" ${ARGN})
    set(TEST_NAME utest_${ADDTEST_NAME})

    foreach(TEST_SOURCE ${ADDTEST_SOURCES})
        list(APPEND TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_SOURCE})
    endforeach()

    add_executable(${TEST_NAME} ${TEST_SOURCES} $<TARGET_OBJECTS:yangobj>)
    target_compile_definitions(${TEST_NAME} PRIVATE LIBYANG_BUILD)

    # Set common attributes of all tests
    set_target_properties(${TEST_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests")
    target_link_libraries(${TEST_NAME} ${CMOCKA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${PCRE2_LIBRARIES} ${CMAKE_DL_LIBS})
    if (NOT WIN32)
        target_link_libraries(${TEST_NAME} m)
    else()
        target_link_libraries(${TEST_NAME} ${COMPAT_WIN_LIBRARIES})
    endif()
    if (NOT APPLE)
        if (ADDTEST_WRAP)
            set_target_properties(${TEST_NAME} PROPERTIES LINK_FLAGS "${ADDTEST_WRAP}")
        endif()
    endif()

    if (XXHASH_FOUND)
        target_link_libraries(${TEST_NAME} ${XXHASH_LIBRARY})
    endif()
    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "MALLOC_CHECK_=3")

    if(ENABLE_VALGRIND_TESTS)
        add_test(${TEST_NAME}_valgrind valgrind --leak-check=full --show-leak-kinds=all --suppressions=${PROJECT_SOURCE_DIR}/tests/ld.supp --error-exitcode=1 ${CMAKE_BINARY_DIR}/tests/${TEST_NAME})
    endif()
endfunction()

add_subdirectory(plugins)
add_subdirectory(utests)
if(NOT WIN32)
    add_subdirectory(style)
    add_subdirectory(fuzz)
    add_subdirectory(perf)
endif()
add_subdirectory(yanglint)
add_subdirectory(yangre)

set(format_sources ${format_sources} PARENT_SCOPE)

=== tools/CMakeLists.txt ===
include(CheckIncludeFile)

# config file for tools
configure_file(${PROJECT_SOURCE_DIR}/tools/config.h.in ${PROJECT_BINARY_DIR}/tools/config.h @ONLY)

# find ioctl
check_include_file("sys/ioctl.h" HAVE_IOCTL)
if(NOT HAVE_IOCTL)
    message(STATUS "Disabling interactive yanglint, sys/ioctl.h not found...")
    set(ENABLE_YANGLINT_INTERACTIVE OFF)
endif()

# find getopt library on WIN32
if(WIN32)
    find_library(GETOPT_LIBRARY NAMES getopt REQUIRED)
    find_path(GETOPT_INCLUDE_DIR NAMES getopt.h REQUIRED)
    message(STATUS "Found <getopt.h> at ${GETOPT_INCLUDE_DIR}, library at ${GETOPT_LIBRARY}")
endif()

add_subdirectory(lint)
add_subdirectory(re)

set(format_sources
    ${format_sources}
    PARENT_SCOPE)

=== tests/fuzz/CMakeLists.txt ===
if(ENABLE_FUZZ_TARGETS)
    set(fuzz_targets lys_parse_mem lyd_parse_mem_xml lyd_parse_mem_json yang_parse_module)

    if(FUZZER STREQUAL "AFL")
        foreach(target_name IN LISTS fuzz_targets)
            add_executable(${target_name}_fuzz_harness ${target_name}.c main.c)
            target_link_libraries(${target_name}_fuzz_harness yang)
        endforeach()
    elseif()
        foreach(target_name IN LISTS fuzz_targets)
            add_executable(${target_name}_fuzz_harness ${target_name}.c)
            set_source_files_properties(${target_name}.c PROPERTIES COMPILE_FLAGS "-fsanitize=fuzzer")
            target_link_libraries(${target_name}_fuzz_harness yang "-fsanitize=fuzzer")
        endforeach()
    endif()
endif()

if(ENABLE_TESTS)
    add_executable(fuzz_regression_test fuzz_regression_test.c)
    set(fuzz_regression_tests lys_parse_mem lyd_parse_mem_xml lyd_parse_mem_json)
    foreach(target_name IN LISTS fuzz_regression_tests)
        file(COPY ${CMAKE_SOURCE_DIR}/tests/fuzz/corpus/${target_name} DESTINATION ${CMAKE_BINARY_DIR}/tests/fuzz/)
        add_executable(regress_fuzz_${target_name} ${target_name}.c main.c)
        set_target_properties(regress_fuzz_${target_name} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests/fuzz/${target_name}")
        target_link_libraries(regress_fuzz_${target_name} yang)
        add_test(NAME regress_fuzz_${target_name} COMMAND fuzz_regression_test regress_fuzz_${target_name} . WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tests/fuzz/${target_name})
    endforeach()
endif()

=== tests/style/CMakeLists.txt ===
add_test(NAME headers
    COMMAND ${CMAKE_SOURCE_DIR}/compat/check_includes.sh ${CMAKE_SOURCE_DIR}/src/ ${CMAKE_SOURCE_DIR}/tools/lint/ ${CMAKE_SOURCE_DIR}/tools/re/)

if(${SOURCE_FORMAT_ENABLED})
    add_test(NAME format WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND cmake --build ${CMAKE_BINARY_DIR} --target format-check)
endif()

# just compile
add_executable(cpp_compat cpp_compat.c $<TARGET_OBJECTS:yangobj>)
target_include_directories(cpp_compat BEFORE PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(cpp_compat ${CMAKE_THREAD_LIBS_INIT} ${PCRE2_LIBRARIES} ${CMAKE_DL_LIBS} m)
if(XXHASH_FOUND)
    target_link_libraries(cpp_compat ${XXHASH_LIBRARY})
endif()

target_compile_options(cpp_compat PUBLIC "-Werror=c++-compat")

=== tests/utests/CMakeLists.txt ===

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/basic/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/data/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/extensions/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/types/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/restriction/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/node/*.c
    PARENT_SCOPE)

ly_add_utest(NAME uint8  SOURCES types/uint8.c)
ly_add_utest(NAME uint16 SOURCES types/uint16.c)
ly_add_utest(NAME uint32 SOURCES types/uint32.c)
ly_add_utest(NAME uint64 SOURCES types/uint64.c)
ly_add_utest(NAME int8   SOURCES types/int8.c)
ly_add_utest(NAME int16  SOURCES types/int16.c)
ly_add_utest(NAME int32  SOURCES types/int32.c)
ly_add_utest(NAME int64  SOURCES types/int64.c)
ly_add_utest(NAME string SOURCES types/string.c)
ly_add_utest(NAME bits   SOURCES types/bits.c)
ly_add_utest(NAME binary SOURCES types/binary.c)
ly_add_utest(NAME inet_types   SOURCES types/inet_types.c)
ly_add_utest(NAME yang_types   SOURCES types/yang_types.c)
ly_add_utest(NAME enumeration  SOURCES types/enumeration.c)
ly_add_utest(NAME instanceid   SOURCES types/instanceid.c)
ly_add_utest(NAME instanceid_keys   SOURCES types/instanceid_keys.c)
ly_add_utest(NAME union        SOURCES types/union.c)
ly_add_utest(NAME boolean      SOURCES types/boolean.c)
ly_add_utest(NAME decimal64    SOURCES types/decimal64.c)
ly_add_utest(NAME empty        SOURCES types/empty.c)
ly_add_utest(NAME identityref  SOURCES types/identityref.c)
ly_add_utest(NAME leafref      SOURCES types/leafref.c)

ly_add_utest(NAME range  SOURCES restriction/test_range.c)
ly_add_utest(NAME pattern  SOURCES restriction/test_pattern.c)

ly_add_utest(NAME list  SOURCES node/list.c)

ly_add_utest(NAME common SOURCES basic/test_common.c)
ly_add_utest(NAME set SOURCES basic/test_set.c)
ly_add_utest(NAME hash_table SOURCES basic/test_hash_table.c)
ly_add_utest(NAME inout SOURCES basic/test_inout.c)
ly_add_utest(NAME context SOURCES basic/test_context.c)
if(NOT WIN32)
ly_add_utest(NAME plugins SOURCES basic/test_plugins.c)
endif()
ly_add_utest(NAME xml SOURCES basic/test_xml.c)
ly_add_utest(NAME json SOURCES basic/test_json.c)
ly_add_utest(NAME xpath SOURCES basic/test_xpath.c)
ly_add_utest(NAME yanglib SOURCES basic/test_yanglib.c)

ly_add_utest(NAME schema SOURCES schema/test_schema.c)
ly_add_utest(NAME yang SOURCES schema/test_yang.c)
ly_add_utest(NAME yin SOURCES schema/test_yin.c)
ly_add_utest(NAME tree_schema_compile SOURCES schema/test_tree_schema_compile.c)
ly_add_utest(NAME printer_tree SOURCES schema/test_printer_tree.c)

ly_add_utest(NAME tree_data SOURCES data/test_tree_data.c)
ly_add_utest(NAME tree_data_sorted SOURCES data/test_tree_data_sorted.c)
ly_add_utest(NAME new SOURCES data/test_new.c)
ly_add_utest(NAME parser_xml SOURCES data/test_parser_xml.c)
ly_add_utest(NAME printer_xml SOURCES data/test_printer_xml.c)
ly_add_utest(NAME printer_json SOURCES data/test_printer_json.c)
ly_add_utest(NAME parser_json SOURCES data/test_parser_json.c)
ly_add_utest(NAME lyb SOURCES data/test_lyb.c)
ly_add_utest(NAME validation SOURCES data/test_validation.c)
ly_add_utest(NAME merge SOURCES data/test_merge.c)
ly_add_utest(NAME diff SOURCES data/test_diff.c)

ly_add_utest(NAME metadata SOURCES extensions/test_metadata.c)
ly_add_utest(NAME nacm SOURCES extensions/test_nacm.c)
ly_add_utest(NAME yangdata SOURCES extensions/test_yangdata.c)
ly_add_utest(NAME schema_mount SOURCES extensions/test_schema_mount.c)
ly_add_utest(NAME structure SOURCES extensions/test_structure.c)

=== tests/yangre/CMakeLists.txt ===
find_program(PATH_TCLSH NAMES tclsh)
find_program(PATH_EXPECT NAMES expect)
if(NOT PATH_TCLSH)
    message(WARNING "tclsh not found, yanglint(1) interactive tests will not be available.")
elseif(NOT PATH_EXPECT)
    message(WARNING "expect not found, yanglint(1) interactive tests will not be available.")
else()
    add_test(NAME "yangre" COMMAND "tclsh" "${CMAKE_CURRENT_SOURCE_DIR}/all.tcl")
    set_property(TEST "yangre" APPEND PROPERTY ENVIRONMENT "TESTS_DIR=${CMAKE_CURRENT_SOURCE_DIR}")
    set_property(TEST "yangre" APPEND PROPERTY ENVIRONMENT "YANGRE=${PROJECT_BINARY_DIR}")
endif()

=== tools/lint/CMakeLists.txt ===
# yanglint
set(lintsrc
    main_ni.c
    cmd.c
    cmd_add.c
    cmd_clear.c
    cmd_data.c
    cmd_list.c
    cmd_feature.c
    cmd_load.c
    cmd_print.c
    cmd_searchpath.c
    cmd_extdata.c
    cmd_help.c
    cmd_verb.c
    cmd_debug.c
    yl_opt.c
    yl_schema_features.c
    common.c
)

if(ENABLE_YANGLINT_INTERACTIVE)
    set(lintsrc ${lintsrc}
        main.c
        completion.c
        configuration.c
        linenoise/linenoise.c
        linenoise/utf8.c)
else()
    set(lintsrc ${lintsrc}
        main_ni_only.c)
endif()

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    PARENT_SCOPE)

add_executable(yanglint ${lintsrc} ${compatsrc})
target_link_libraries(yanglint yang)
install(TARGETS yanglint DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${PROJECT_SOURCE_DIR}/tools/lint/yanglint.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
target_include_directories(yanglint BEFORE PRIVATE ${PROJECT_BINARY_DIR})

if(WIN32)
    target_include_directories(yanglint PRIVATE ${GETOPT_INCLUDE_DIR})
    target_link_libraries(yanglint ${GETOPT_LIBRARY})
endif()

=== debian/changelog ===
libyang (3.13.6-1) sid; urgency=medium

  * Removing rules-requires-root, not needed anymore.
  * Merging upstream version 3.13.6.
  * Updating watch file to version 5.
  * Updating copyright for upstream version 3.13.6 (Closes: #1118631).

 -- Daniel Baumann <daniel@debian.org>  Sat, 01 Nov 2025 06:36:08 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,6 @@
  pkgconf,
  tcl-expect <!nocheck>,
  tclsh <!nocheck>,
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Homepage: https://github.com/CESNET/libyang
 Vcs-Browser: https://forgejo.debian.net/frr/libyang

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh ${@}

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Release" \
		-DENABLE_TESTS=ON

ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	$(MAKE) -C obj-*/ doc
endif

=== debian/watch ===
Version: 5

Template: Github
Owner: CESNET
Project: @PACKAGE@
Dversion-Mangle: auto

## libyang 4.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,15 +58,15 @@
 set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
 
 # set version of the project
-set(LIBYANG_MAJOR_VERSION 3)
-set(LIBYANG_MINOR_VERSION 13)
-set(LIBYANG_MICRO_VERSION 6)
+set(LIBYANG_MAJOR_VERSION 4)
+set(LIBYANG_MINOR_VERSION 2)
+set(LIBYANG_MICRO_VERSION 2)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
-set(LIBYANG_MAJOR_SOVERSION 3)
-set(LIBYANG_MINOR_SOVERSION 9)
-set(LIBYANG_MICRO_SOVERSION 14)
+set(LIBYANG_MAJOR_SOVERSION 4)
+set(LIBYANG_MINOR_SOVERSION 2)
+set(LIBYANG_MICRO_SOVERSION 2)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})
 
@@ -75,7 +75,7 @@
     set(C_STANDARD_REQUIRED ON)
     set(CMAKE_C_FLAGS "/Zc:preprocessor /W3 /wd4711 /w14013 /utf-8 ${CMAKE_C_FLAGS}")
 else()
-    # global C flags
+    # global C flags (POSIX source because of pthread_rwlock_t)
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wpedantic -std=c11")
 endif()
 
@@ -149,6 +149,7 @@
     src/printer_yang.c
     src/printer_yin.c
     src/printer_tree.c
+    src/printer_context.c
     src/plugins.c
     src/plugins_types.c
     src/plugins_exts.c
@@ -215,6 +216,7 @@
     doc/build.dox
     doc/transition_1_2.dox
     doc/transition_2_3.dox
+    doc/transition_3_4.dox
     ${headers}
     ${PROJECT_BINARY_DIR}/libyang/version.h
     ${type_plugins})
@@ -382,6 +384,3 @@
     if(TARGET yangobj)
         target_include_directories(yangobj PRIVATE ${COMPAT_POSIX_INCLUDES})
     endif()
-    target_include_directories(yang PRIVATE ${COMPAT_POSIX_INCLUDES})
-    include_directories(${COMPAT_POSIX_INCLUDES})
-

=== debian/changelog ===
libyang (4.2.2-2) experimental; urgency=medium

  * Dropping pre-trixie breaks/replaces.
  * Temporarily avoid failing the build if test suite fails.

 -- Daniel Baumann <daniel@debian.org>  Mon, 08 Dec 2025 16:47:40 +0100

libyang (4.2.2-1) experimental; urgency=medium

  * Merging upstream version 4.2.2.
  * Updating packaging for soname bump to 4.
  * Rather than to rename the tools package to libyang4-tools for the
    soname bump, we'll use the opportunity to avoid it in the future as
    it's not needed to be versioned.

 -- Daniel Baumann <daniel@debian.org>  Fri, 05 Dec 2025 07:34:46 +0100

=== debian/rules ===
--- 
+++ 
@@ -16,3 +16,6 @@
 execute_after_dh_auto_build:
 	$(MAKE) -C obj-*/ doc
 endif
+
+override_dh_auto_test:
+	dh_auto_test || true

## libyang 4.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,14 +59,14 @@
 
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 4)
-set(LIBYANG_MINOR_VERSION 2)
-set(LIBYANG_MICRO_VERSION 2)
+set(LIBYANG_MINOR_VERSION 3)
+set(LIBYANG_MICRO_VERSION 3)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 4)
-set(LIBYANG_MINOR_SOVERSION 2)
-set(LIBYANG_MICRO_SOVERSION 2)
+set(LIBYANG_MINOR_SOVERSION 3)
+set(LIBYANG_MICRO_SOVERSION 3)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

=== debian/changelog ===
libyang (4.3.3-1) experimental; urgency=medium

  * Merging upstream version 4.3.3.
  * Removing cherry-picked patches, included upstream.

 -- Daniel Baumann <daniel@debian.org>  Sat, 13 Dec 2025 07:16:40 +0100

libyang (4.2.2-3) experimental; urgency=medium

  * Cherry-picking patches from upstream to fix test-suite failures mostly
    on 32bit platforms.
  * Making failures fatal again.

 -- Daniel Baumann <daniel@debian.org>  Fri, 12 Dec 2025 11:57:58 +0100

## libyang 4.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,13 +60,13 @@
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 4)
 set(LIBYANG_MINOR_VERSION 3)
-set(LIBYANG_MICRO_VERSION 3)
+set(LIBYANG_MICRO_VERSION 4)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 4)
 set(LIBYANG_MINOR_SOVERSION 3)
-set(LIBYANG_MICRO_SOVERSION 3)
+set(LIBYANG_MICRO_SOVERSION 4)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

=== debian/changelog ===
libyang (4.3.4-1) experimental; urgency=medium

  * Merging upstream version 4.3.4.

 -- Daniel Baumann <daniel@debian.org>  Wed, 17 Dec 2025 19:34:15 +0100

=== debian/control ===
--- 
+++ 
@@ -23,13 +23,13 @@
 Architecture: any
 Depends:
  libpcre2-dev,
- libyang3 (= ${binary:Version}),
+ libyang4 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
- libyang2-dev,
+ libyang3-dev,
 Replaces:
- libyang2-dev,
+ libyang3-dev,
 Description: parser toolkit for IETF YANG data modeling language (development)
  YANG is a data modeling language for the definition of data sent over network
  management protocols (RFC 6020/7950). It can be used to model both configuration
@@ -38,7 +38,7 @@
  .
  This package contains the development files.
 
-Package: libyang3
+Package: libyang4
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -48,11 +48,9 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
- libyang2,
- libyang2t64,
+ libyang3,
 Replaces:
- libyang2,
- libyang2t64,
+ libyang3,
 Description: parser toolkit for IETF YANG data modeling language (library)
  YANG is a data modeling language for the definition of data sent over network
  management protocols (RFC 6020/7950). It can be used to model both configuration
@@ -61,7 +59,7 @@
  .
  This package contains the shared library.
 
-Package: libyang3-tools
+Package: libyang-tools
 Section: devel
 Architecture: any
 Multi-Arch: foreign
@@ -71,9 +69,9 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
- libyang2-tools,
+ libyang3-tools,
 Replaces:
- libyang2-tools,
+ libyang3-tools,
 Description: parser toolkit for IETF YANG data modeling language (tools)
  YANG is a data modeling language for the definition of data sent over network
  management protocols (RFC 6020/7950). It can be used to model both configuration
